(function(angular, $, _) {
	
	angular.module('form_processor').directive('crmFormProcessorActions', function(formProcessorFactory, dialogService, $timeout) {
	  return {
	    restrict: 'E',
	    scope: {
	    	inputs: '=',
	      actions: '=',
	      actionTypes: '=',
	      formProcessor: '=',
	      deletedActions: '=',
	      entity: '@',
	    },
	    templateUrl: '~/form_processor/actions/crmFormProcessorActions.html',
	    link: function($scope, element, attrs){
	    	$scope.ts = CRM.ts(null);
	    	
		    for(var i=0; i<$scope.actionTypes.length; i++) {
		    	if ($scope.actionTypes[i].description) {
		    		$scope.actionTypes[i].description = $sce.trustAsHtml($scope.actionTypes[i].description);
		    	}
		    }
	    	
	    	$scope.new_id = -1;
	    	
	    	$timeout(function(){
		    	// The select boxes for input type and action type do not count for the @pristine state of the
		    	// form.
		  		$scope.formProcessorActionsForm.type.$pristine = false;
				});
	    	
	    	$scope.removeAction = function removeAction(action) {
		    	var index = $scope.actions.indexOf(action);
		    	if (index >= 0) {
		    		$scope.actions.splice(index, 1);
		    		$scope.deletedActions.push(action);
		    	}
		    	$scope.formProcessorActionsForm.$setDirty();
		    };
		  
		   	// Open a dialog for adding an action
		    $scope.addAction = function addAction(actionType) {
		    	if (!actionType) {
		    		return;
		    	}    
		      var action = {
		    		id: $scope.new_id,
		    		type: angular.copy(actionType),
		      	'title': '',
		      	'name': '',
		  			'configuration': angular.copy(actionType.default_configuration),
		  			'mapping': {}
		      };
		      $scope.editAction(action);
		    };
		    
		    // Open a dialog for editting an action
		    $scope.editAction = function editAction(action) {    	    	
		      var options = CRM.utils.adjustDialogDefaults({
		        autoOpen: false,
		        width: '40%',
		        height: '80%',
		        title: ts('Edit action')
		      });
		      
		      var fields = formProcessorFactory.getFieldList($scope.inputs, $scope.actions, action);
		      index = $scope.actions.indexOf(action);
		      var model = {
		      	formProcessor: $scope.formProcessor,
		      	action: action,
		      	fields: fields,
		      	entity: $scope.entity
		      };
		      dialogService.open('ActionDialog', '~/form_processor/actions/ActionDialogCtrl.html', model, options)
		      .then(function(data) {
		      	$scope.formProcessorActionsForm.$setDirty();		      	
		      	if (index >= 0) {
		      		$scope.actions[index] = data.action;
		      	} else if ($scope.new_id == data.action.id) {
							$scope.actions.push(data.action);
							$scope.new_id --;
						}
					});
		    };
	    }
	  };
	});
	
})(angular, CRM.$, CRM._);